{
Copyright () 2005,  by Germn Estvez (Neftal)
http://neftali.clubdelphi.com/

  Muestra cmo mover una imagen utilizando el ratn en ejecucin.

=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras, ampliaciones,
  errores y/o cualquier otro tipo de sugerencia envame un mail a:
  german_ral@hotmail.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
errors and/or any another type of suggestion send a mail to:
german_ral@hotmail.com
=========================================================================

@author Germn Estvez (Neftal)
@cat Samples
}
unit Unit1_Mover_Imagen;

//=========================================================================
//
// I N T E R F A C E
//
//=========================================================================
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ShellAPI;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    btnCerrar: TButton;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1DblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btnCerrarClick(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);

  private
    { Private declarations }
     nmesas:Integer;
     Capturing:Boolean;
     MouseDownSpot:TPoint;

     LAst:TImage;


     procedure Delete(img:TImage);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation

{$R *.dfm}

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Capturing then begin
    TImage(Sender).Left := TImage(Sender).Left - (MouseDownSpot.x - x);
    TImage(Sender).Top := TImage(Sender).Top - (MouseDownSpot.y - y);

    StatusBar1.Panels[0].Text := IntToStr(TImage(Sender).Left) + ' - ' + IntToStr(TImage(Sender).Top);
    TImage(Sender).Hint := StatusBar1.Panels[0].Text;
    TImage(Sender).ShowHint := True;
    
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Capturing then begin
    ReleaseCapture;
    Capturing := false;
    TImage(Sender).Left := TImage(Sender).Left - (MouseDownSpot.x - x);
    TImage(Sender).Top := TImage(Sender).Top - (MouseDownSpot.y - y);

  end;

  if (Sender is TImage) then begin
    Last := TImage(Sender);
  end;

end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Capturing := true;
  MouseDownSpot.X := x;
  MouseDownSpot.Y := Y;
  StatusBar1.Panels[0].Text := '';
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  with timage.Create(Image1) do
  begin

    picture := Image1.picture;

    name := 'MS_' + inttostr(nmesas);
    nmesas := nmesas + 1;

    Stretch := True;

    Parent := Panel1;

    Left := 10;

    Top := 10;

    height := 57;

    width := 61;

    Transparent := true;

    onMouseDown := Image1MouseDown;

    onMouseMove := Image1MouseMove;

    onMouseUp := Image1MouseUp;

    onDblClick := Image1DblClick;

  end;



end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
  if (Sender is TiMAGE) then begin
    // Borrar
    Delete(Timage(sender));
  END;
end;

procedure TForm1.Delete(img: TImage);
begin
  img.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Assigned (Last) then begin
    Last.Free;
    Last := nil;
  end;
end;

procedure TForm1.btnCerrarClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.StatusBar1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://neftali.clubdelphi.com/', 0, 0, 0);
end;

end.


